import es, cfglib

info = es.AddonInfo()
info['name']        = "Hit Groups"
info['version']     = "1.0.0"
info['author']      = "DanielB" 
info['url']         = "http://forums.eventscripts.com/viewtopic.php?t=34141" 
info['description'] = "Blocks specified hitgroups from taking damage" 

dm = es.import_addon('dm')


if not dm.minver('2.0.3'):
    raise NotImplementedError, 'Please update your dm version'
if dm.usePureES:
    raise NotImplementedError, 'This addon require SPE or NT to run'
    
    
class Settings(object):
    config = cfglib.AddonCFG(dm.addondir + '/dm/addons/hitgroups/settings.cfg')
    
    config.text('For information on hitgroups, go to')
    config.text('http://www.eventscripts.com/pages/Hit_Groups')
    _blocked = config.cvar('dm_hitgroups_block', '1', 'Hitgroup numbers to block seperated by a ,'), str
    
    config.execute()
    
    def __init__(self):
        self.config.write()
        
    def __getattr__(self, name):
        if hasattr(Settings, name):
            return super(Settings, self).__getattribute__(name)
           
        elif hasattr(Settings, '_'+name):
            val, func = super(Settings, self).__getattribute__('_'+name)
            return func(val)
           
        raise AttributeError, 'No such attribute "%s"'%name
        
settings = Settings()
        
        
    
def load():
    dm.registerPreHook('player_hurt', pre_player_hurt)
    dm.msg('Loaded Addon - Hit Groups')
    
def unload():
    dm.unregisterPreHook('player_hurt', pre_player_hurt)
    dm.msg('Unloaded Addon - Hit Groups')
    
def pre_player_hurt(event_var):
    attacker = event_var['attacker']
    victim = event_var['userid']
    if int(attacker) and attacker != victim:
        weapon = event_var['weapon']
        damage = event_var['dmg_health']
        hitgroup = str(event_var['hitgroup'])
        
    blocked_hitgroups = settings.blocked.split(',')
    if hitgroup in blocked_hitgroups:
        health = int(es.getplayerprop(victim, 'CBasePlayer.m_iHealth'))
        es.setplayerprop(victim, 'CBasePlayer.m_iHealth', health+int(damage))
    
    
    